using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Telerik.WebControls;

/// <summary>
/// Summary description for MyTemplateColumn
/// </summary>
namespace MyNamespace
{
    public class MyCustomFilteringColumn : Telerik.WebControls.GridTemplateColumn
    {
        public MyCustomFilteringColumn()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        protected override void SetupFilterControls(TableCell cell)
        {
           

            RadComboBox combo = new RadComboBox();
            combo.ID = "RadComboBox1_" + this.UniqueName;
            RadComboBoxItem item = new RadComboBoxItem();
            item.Selected = true;
            combo.Items.Add(item);
            combo.ItemTemplate = new ComboTemplate();

            Button buttonOK = combo.SelectedItem.FindControl("ButtonOK") as Button;
            buttonOK.CommandArgument = this.UniqueName;

            Button buttonClear = combo.SelectedItem.FindControl("ButtonClear") as Button;
            buttonClear.CommandArgument = this.UniqueName;

            cell.Controls.Add(combo);
            
            cell.Controls.Add(
                new LiteralControl(
                    String.Format("<script type='text/javascript'>PrepareComboForDisposal('{0}');</script>",
                                  combo.ClientID)));
            
        }
        
        protected override void SetCurrentFilterValueToControl(TableCell cell)
        {
            base.SetCurrentFilterValueToControl(cell);
            try
            {
                RadComboBox combo = (RadComboBox) cell.Controls[0];
                RadDatePicker dpStart = (RadDatePicker)combo.SelectedItem.FindControl("RadDatePicker1");
                RadDatePicker dpEnd = (RadDatePicker)combo.SelectedItem.FindControl("RadDatePicker2");

                if (HttpContext.Current.Session[this.UniqueName + "_StartDate"] != null && HttpContext.Current.Session[this.UniqueName + "_EndDate"] != null)
                {
                    DateTime startDate = DateTime.Parse(HttpContext.Current.Session[this.UniqueName + "_StartDate"].ToString());
                    DateTime endDate = DateTime.Parse(HttpContext.Current.Session[this.UniqueName + "_EndDate"].ToString());
                    if (startDate != DateTime.MinValue)
                    {
                        dpStart.SelectedDate = startDate;
                    }
                    if (endDate != DateTime.MinValue)
                    {
                        dpEnd.SelectedDate = endDate;
                    }
                }
                
            }
            catch
            {
            }
        }

        protected override string GetCurrentFilterValueFromControl(TableCell cell)
        {
            RadComboBox combo = (RadComboBox)cell.Controls[0];
            RadDatePicker dpStart = (RadDatePicker)combo.SelectedItem.FindControl("RadDatePicker1");
            RadDatePicker dpEnd = (RadDatePicker)combo.SelectedItem.FindControl("RadDatePicker2");
            
            string currentValue = "";
            
            if (!dpStart.IsEmpty && !dpEnd.IsEmpty)
            {
                this.CurrentFilterFunction = GridKnownFunction.Between;
                currentValue = dpStart.SelectedDate.ToString() + " AND " + dpEnd.SelectedDate.ToString();
            }
            else
            {
                this.CurrentFilterFunction = GridKnownFunction.NoFilter;
            }
            return currentValue;

        }
        
    }
    
    class ComboTemplate : ITemplate
    {
        #region ITemplate Members

        public void InstantiateIn(Control container)
        {
            HtmlTable table = new HtmlTable();

            HtmlTableRow row = new HtmlTableRow();
            RadDatePicker startPicker = new RadDatePicker();
            startPicker.ID = "RadDatePicker1";
            startPicker.FocusedDate = new DateTime(1996, 7, 1);
            HtmlTableCell cell = new HtmlTableCell();
            cell.Controls.Add(startPicker);
            row.Controls.Add(cell);

            RadDatePicker endPicker = new RadDatePicker();
            endPicker.ID = "RadDatePicker2";
            endPicker.FocusedDate = new DateTime(1996, 7, 1);
            cell = new HtmlTableCell();
            cell.Controls.Add(endPicker);
            row.Controls.Add(cell);

            row.Attributes.Add("onclick", "PreventDropDownClose(event);");
            table.Rows.Add(row);

            row = new HtmlTableRow();
            cell = new HtmlTableCell();
            Button btn = new Button();
            btn.ID = "ButtonOK";
            btn.Text = "OK";
            btn.CommandName = "DateFilter";
            btn.Width = Unit.Pixel(40);
            cell.Controls.Add(btn);
            row.Controls.Add(cell);

            cell = new HtmlTableCell();
            btn = new Button();
            btn.ID = "ButtonClear";
            btn.Text = "Clear";
            btn.CommandName = "Clear";
            btn.Width = Unit.Pixel(40);
            cell.Controls.Add(btn);
            row.Controls.Add(cell);
            table.Rows.Add(row);

            container.Controls.Add(table);
        }

        #endregion
    }
}