using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Telerik.WebControls;

public partial class Default2 : System.Web.UI.Page
{
    protected void RadGrid1_ItemCommand(object source, Telerik.WebControls.GridCommandEventArgs e)
    {
        if (e.CommandName == "DateFilter")
        {
            string columnName = e.CommandArgument.ToString();

            TableCell cell = ((Telerik.WebControls.GridFilteringItem)e.Item)[columnName];

            RadComboBox combobox = (RadComboBox)cell.Controls[0];//.FindControl("RadComboBox1");
            RadDatePicker dp1 = (RadDatePicker)combobox.SelectedItem.FindControl("RadDatePicker1");
            RadDatePicker dp2 = (RadDatePicker)combobox.SelectedItem.FindControl("RadDatePicker2");

            Session[columnName + "_StartDate"] = dp1.SelectedDate;
            Session[columnName + "_EndDate"] = dp2.SelectedDate;

            if (RadGrid1.MasterTableView.FilterExpression != "")
            {
                RadGrid1.MasterTableView.FilterExpression = ClearFilterExpression(RadGrid1.MasterTableView.FilterExpression, columnName);
                if (RadGrid1.MasterTableView.FilterExpression != "")
                {
                    RadGrid1.MasterTableView.FilterExpression += " AND";
                }
                RadGrid1.MasterTableView.FilterExpression += String.Format(" {0} > '{1}' AND {0} < '{2}'", columnName, dp1.SelectedDate.ToString(), dp2.SelectedDate.ToString());
            }
            else
            {
                RadGrid1.MasterTableView.FilterExpression += String.Format("{0} > '{1}' AND {0} < '{2}'", columnName, dp1.SelectedDate.ToString(), dp2.SelectedDate.ToString());
            }
            RadGrid1.MasterTableView.Rebind();
        }
        else if (e.CommandName == "Clear")
        {
            string columnName = e.CommandArgument.ToString();

            TableCell cell = ((Telerik.WebControls.GridFilteringItem)e.Item)[columnName];
            RadComboBox combobox = (RadComboBox)cell.Controls[0].FindControl("RadComboBox1");
            RadDatePicker dp1 = (RadDatePicker)combobox.SelectedItem.FindControl("RadDatePicker1");
            RadDatePicker dp2 = (RadDatePicker)combobox.SelectedItem.FindControl("RadDatePicker2");

            dp1.Clear();
            dp2.Clear();

            Session[columnName + "_StartDate"] = null;
            Session[columnName + "_EndDate"] = null;

            e.Item.OwnerTableView.FilterExpression = ClearFilterExpression(e.Item.OwnerTableView.FilterExpression, columnName);
            e.Item.OwnerTableView.Rebind();
        }
    }
    protected void Button1_Click(object sender, EventArgs e)
    {
        foreach (GridColumn column in RadGrid1.MasterTableView.Columns)
        {
            column.CurrentFilterFunction = GridKnownFunction.NoFilter;
            column.CurrentFilterValue = String.Empty;
        }
        Session["StartDate"] = null;
        Session["EndDate"] = null;

        RadGrid1.MasterTableView.FilterExpression = String.Empty;
        RadGrid1.MasterTableView.Rebind();
    }
    
    private string ClearFilterExpression(string filterExpression, string columnName)
    {
        string[] filterExpressionParts = filterExpression.Split(new string[] { " AND " }, StringSplitOptions.None);
        ArrayList list = new ArrayList(filterExpressionParts);
        for (int i = list.Count - 1; i >= 0; i--)
        {
            if (list[i].ToString().StartsWith(columnName))
            {
                list.Remove(list[i]);
            }
        }
        filterExpressionParts = (string[])list.ToArray(typeof(string));
        return string.Join(" AND ", filterExpressionParts);
    }

    
}
